CLEAR

#define GMEM_FIXED          0x0000
#define GMEM_MOVEABLE       0x0002
#define GMEM_NOCOMPACT      0x0010
#define GMEM_NODISCARD      0x0020
#define GMEM_ZEROINIT       0x0040
#define GMEM_MODIFY         0x0080
#define GMEM_DISCARDABLE    0x0100
#define GMEM_NOT_BANKED     0x1000
#define GMEM_SHARE          0x2000
#define GMEM_DDESHARE       0x2000
#define GMEM_NOTIFY         0x4000
#define GMEM_LOWER          GMEM_NOT_BANKED
#define GMEM_VALID_FLAGS    0x7F72
#define GMEM_INVALID_HANDLE 0x8000


DECLARE INTEGER GetLastError IN kernel32.DLL
DECLARE INTEGER CloseHandle IN kernel32.DLL INTEGER hObject
DECLARE INTEGER SetClipboardData  IN WIN32API INTEGER uFormat, INTEGER hMem 


DECLARE INTEGER GlobalAlloc IN KERNEL32.DLL INTEGER, INTEGER 
DECLARE INTEGER GlobalLock IN WIN32API INTEGER
DECLARE INTEGER GlobalUnlock IN WIN32API INTEGER
DECLARE INTEGER GlobalFree IN WIN32API INTEGER

Declare INTEGE RtlMoveMemory IN win32api Integer dest, STRING src, Integer nsize 

DECLARE INTEGER OpenClipboard IN WIN32API INTEGER
DECLARE INTEGER CloseClipboard IN WIN32API
DECLARE LONG EmptyClipboard IN user32

LOCAL lcPath,lcAlias,lihFile,lcOutFile,lcPom,lnSize,lnPointer,lnPointerN,lihMem,lcData,liLen,llDal,;
      loExcel,loSheet,loWorkbook
LOCAL laDir(1)
lcPath=SYS(16)
lcPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)

lcAlias=SYS(2015)
lcOutFile=lcPath+"test.txt"

USE (lcPath+"test.dbf") ALIAS (lcAlias) IN 0


SELECT (lcAlias)
IF FILE(lcOutFile) 
   DELETE FILE (lcOutFile)
ENDIF

COPY TO (lcOutFile) DELIMITED WITH TAB
USE
ADIR(laDir,lcOutFile)
lnSize=laDir(1,2)

STORE 0 TO lihMem,lnPointer,lnPointerN,lihFile

* Oteven suboru
lihFile=FOPEN(lcOutFile,0)
IF lihFile<=0
   llDal=.F.
   MESSAGEBOX("Nepodailo se otevt soubor")
ENDIF
 


* Alokace pamti
IF llDal
   lihMem=GlobalAlloc(GMEM_MOVEABLE,lnSize)

   IF lihMem=0
      llDal=.F.
      MESSAGEBOX("Nepodailo se na alokovat potebnou pam")
   ENDIF
ENDIF

IF llDal
   STORE GlobalLock(lihMem) TO lnPointer,lnPointerN

   IF lnPointer=0
      llDal=.F.
      MESSAGEBOX("Nepodailo se zamknout potebnou pam")
   ENDIF
ENDIF


IF llDal
   * Kopie souboru do pamti
   *=RtlMoveMemory(lnPointer,lihMapV,lnSize)
   DO WHILE !FEOF(lihFile)
      lcData=FREAD(lihFile,10000000)
      liLen=LEN(lcData)
      IF VAL(SUBSTR(VERSION(),15,2))>=7
         =SYS(2600,lnPointerN,liLen,lcData)
      ELSE
         =RtlMoveMemory(lnPointerN,lcData,liLen)
      ENDIF
      lnPointerN=lnPointerN+liLen
   ENDDO 

   * Oteven clipboardu a jeho nastaven
   =OpenClipboard(0)
   =EmptyClipboard()
   =SetClipBoardData(1,lnPointer)
   *?GetLastError()
   =CloseClipboard()

   * Vloen do Excelu pomoc OLE
   loExcel=CREATEOBJECT("Excel.Application")
   loWorkbook=loExcel.Workbooks.Add()
   loWorkBook.ActiveSheet.Paste()
   loExcel.Visible=.T.
   loWorkbook=.NULL.
   loExcel=.NULL.

   GlobalUnlock(lihMem)
ENDIF

* Uvolnn vech alokovanch zdroj
IF lihMem>0
   =GlobalFree(lihMem)
ENDIF
IF lihFile>0
   =FCLOSE(lihFile) 
ENDIF
